import { type TNode, type TProperty, type TStyle, type TElement } from "./template.js";
export declare const EMPTY_ARRAY: any[];
export type SAny = undefined;
export type SNode = undefined;
export type SNode1 = undefined;
export type SNode2 = undefined;
export type SRoot = undefined;
export type SText = undefined;
export type STemplate = undefined;
export type SList = undefined;
export type SContext = undefined;
export type SComponent = undefined;
export type Root = undefined;
export type Component = undefined;
export type VAny = null | undefined | false | string | number | VTemplate | VComponent | VContext | VAny[];
export declare const enum VNodeType {
    Template = 0,
    Component = 1,
    Context = 2
}
export interface TemplateDescriptor {
    readonly t: VNodeType.Template;
    readonly s: TNode[];
}
export interface VTemplate {
    readonly d: TemplateDescriptor;
    /** Expressions. */
    readonly p: any[] | undefined;
}
export interface ComponentDescriptor<P = any> {
    readonly t: VNodeType.Component;
    readonly s: (component: Component) => (props: P) => VAny;
}
export interface VComponent<P = any> {
    readonly d: ComponentDescriptor<P>;
    /** Component Props. */
    readonly p: P;
}
export interface ContextDescriptor<T = any> {
    readonly t: VNodeType.Context;
    readonly s: T;
}
export interface ContextProps<T = any> {
    /** Context Value. */
    readonly v: T;
    /** Context Children. */
    readonly c: VAny;
}
export interface VContext<T = any> {
    readonly d: ContextDescriptor<T>;
    readonly p: ContextProps<T>;
}
export type VList = VAny[];
export declare const defineRoot: (arg1: any) => void;
export declare const context: <T>() => [get: (component: Component) => T | undefined, provider: (value: T, children: VAny) => VContext<T>];
export type ContextType<T> = ContextDescriptor<T>;
export type ComponentFactory = {
    (factory: (c: Component) => () => VAny, areEqual?: () => boolean): () => VComponent<undefined>;
    <P>(factory: (c: Component) => (props: P) => VAny, areEqual?: (prev: P, next: P) => boolean): (props: P) => VComponent<P>;
};
export declare const component: ComponentFactory;
export declare const getProps: (component: any) => any;
export type UseEffectFactory = {
    (ccomponent: Component, effect: () => (() => void) | void): () => void;
    <P>(component: Component, effect: (props: P) => (() => void) | void, areEqual?: (prev: P, next: P) => boolean): (props: P) => void;
};
/** Returns noop function. */
export declare const useEffect: UseEffectFactory;
/** Returns noop function. */
export declare const useLayoutEffect: UseEffectFactory;
/** Returns noop function. */
export declare const useIdleEffect: UseEffectFactory;
export declare const List: <E, K>(entries: E[], getKey: (entry: E, index: number) => K, render: (entry: E) => VAny) => VAny;
export declare const _$T: (s: TNode[]) => TemplateDescriptor;
export declare const _$E: (flags: number, prefix: string, suffix: string, props: TProperty[] | null, style: TStyle | null, children: TNode[] | number | null, directives: number[] | null) => TElement;
export declare const _$P: (prefix: string, flags: number, i: number) => TProperty;
export declare const _$S: (stat: string, dyn: TProperty[] | null) => TStyle;
export declare const _$t: (d: TemplateDescriptor, p?: any[]) => VTemplate;
export declare const renderToString: (v: any) => string;
export declare const invalidate: () => never;
export declare const useUnmount: () => never;
export declare const createRoot: () => never;
export declare const dirtyCheck: () => never;
export declare const update: () => never;
export declare const unmount: () => never;
export declare const hydrate: () => never;
//# sourceMappingURL=core.d.ts.map