export type TNode = TElement | string | number;
export interface TElement {
    readonly flags: number;
    readonly prefix: string;
    readonly suffix: string;
    readonly props: TProperty[] | null;
    readonly style: TStyle | null;
    readonly children: TNode[] | number | null;
    readonly directives: number[] | null;
}
export declare const enum TFlags {
    GenerateOffsets = 1,
    EscapeInnerHTML = 2,
    IgnoreEmptyString = 1
}
export interface TProperty {
    /** Property prefix. */
    readonly prefix: string;
    /** Property flags. */
    readonly flags: number;
    /** Expression index. */
    readonly i: number;
}
export interface TStyle {
    /** Static style. */
    readonly stat: string;
    /** Dynamic style. */
    readonly dyn: TProperty[] | null;
}
//# sourceMappingURL=template.d.ts.map