import { type Component } from "./core.js";
/**
 * Dispatch Event options.
 */
export interface DispatchEventOptions {
    /**
     * Option indicating whether the event bubbles. The default is `true`.
     */
    bubbles?: boolean;
    /**
     * Option indicating whether the event can be cancelled. The default is
     * `false`.
     */
    cancelable?: boolean;
    /**
     * Option indicating whether the event will trigger listeners outside of a
     * shadow root. The default is `false`.
     */
    composed?: boolean;
}
export type EventDispatcher = {
    (component: Component): boolean;
    <T>(component: Component, value: T): boolean;
};
export declare const eventDispatcher: (eventType: string, options?: DispatchEventOptions) => EventDispatcher;
export declare const _eventDispatcher: () => never;
export declare const findDOMNode: () => never;
export declare const containsDOMElement: () => never;
export declare const hasDOMElement: () => never;
//# sourceMappingURL=utils.d.ts.map